using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Threading;
using Kaktus.Upload;

namespace Upload
{
	public class Progress : System.Web.UI.Page
	{

		protected Label downloaded;
		protected Label speed;
		protected Label time;
		protected Label file;
		protected HtmlGenericControl bar;

		private void Page_Load(object sender, System.EventArgs e)
		{

			string upload_guid = Request.QueryString["UPLID"];

			// done?
			string done_sesssion_id = "UPLD" + upload_guid + "DONE";
			if (Session[done_sesssion_id] != null)
			{

				Session.Remove(done_sesssion_id);

				Page.RegisterStartupScript("close",
					"<script language=\"javascript\">window.close();</script>");

			}

			// POST is in progress
			else
			{

				// retrieve the information about the request
				UploadedFile file_info = UploadModule.GetFile(upload_guid);

				// the information is available -> update page
				if (file_info != null)
				{

					file_info.ComputeSpeed();
					
					downloaded.Text =
						string.Format("{0} / {1} ({2:0%})",
						file_info.BytesDoneString,
						file_info.TotalBytesString,
						file_info.DonePercents);
					
					speed.Text =
						string.Format("{0}",
						file_info.AvgSpeedString);
					
					time.Text =
						string.Format("{0}",
						file_info.TimeLeftString);
					
					bar.Style["width"] =
						file_info.DonePercents.ToString("0%");
					
					file.Text =
						file_info.CurrentFile;
					
				}

				// refresh the page
				Response.AddHeader(
					"Refresh",
					"1,Progress.aspx?UPLID=" + upload_guid);
			}

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
